﻿using C1.WPF.FlexGrid;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ChangeDefaultSettings_FlexViewer
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            //Handle PreviewMouseDown on Paste menu item to add rows/columns if required.
            flexSheet.ContextMenu.GetMenuItem(ContextMenuCommands.Paste).PreviewMouseDown += MainWindow_PreviewMouseDown;
        }

        private void MainWindow_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            PerformPaste();
        }
        private void FlexSheet_Loaded(object sender, RoutedEventArgs e)
        {
            flexSheet.AddSheet("Sheet 1", 70, 20);          
        }

        private void FlexSheet_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            if(Keyboard.Modifiers == ModifierKeys.Control && e.Key == Key.V)
            {
                PerformPaste();
            }            
        }
        /// <summary>
        /// Adds additional rows/coolumns if needed to paste all the copied data
        /// </summary>
        private void PerformPaste()
        {
            var currentRow = flexSheet.Selection.TopRow;
            var currentCol = flexSheet.Selection.LeftColumn;

            var rowCount = Clipboard.GetText().Split(new char[] { '\n' }, StringSplitOptions.RemoveEmptyEntries).Count();
            var neededRows = rowCount - (flexSheet.Rows.Count - currentRow);
            var neededColumns = Clipboard.GetText().Split(new char[] { '\t' }, StringSplitOptions.RemoveEmptyEntries).Count() / rowCount - (flexSheet.Columns.Count - currentCol - 1);
            if (neededRows > 0)
                for (int i = 1; i <= neededRows; i++)
                    flexSheet.Rows.Add(new Row());

            if (neededColumns > 0)
                for (int i = 1; i <= neededColumns; i++)
                    flexSheet.Columns.Add(new Column());
        }
    }
}
